#!ruby -Ks

class Grid
	def initialize
		@x_max = 79	#Obh̐()
		@y_max = 59	#Obh̐(c)
		@sheet_x = 0
		@sheet_y = 0
		
		@w = []				#Obh̕
		0.upto(@x_max-1) {|i|
			@w[i] = 8
			@sheet_x += @w[i]
		}
		@h = []				#Obh̍
		0.upto(@y_max-1) {|i|
			@h[i] = 8
			@sheet_y += @h[i]
		}
	end
	
	attr_accessor :x_max
	attr_accessor :y_max
	attr_accessor :w
	attr_accessor :h
	attr_accessor :sheet_x
	attr_accessor :sheet_y
	
	def x(i)
		temp_x = 0
		0.upto(i) {|k|
			temp_x += @w[k]
		}
		return x
	end
	
	def y(i)
		temp_y = 0
		0.upto(i){|k|
			temp_y += @h[k]
		}
	end
	
	def x_index(x)
		temp_x = 0
		@w.each_with_index{|e,i|
			temp_x += e
			return i if(x <= temp_x)
		}
	end
	
	def y_index(x)
		temp_y = 0
		@h.each_with_index{|e,i|
			temp_y += e
			return i if(y <= temp_y)
		}
	end
	
	def line_x(n)
		tmp_x = 0
		0.upto(n) {|i|
			tmp_x += @w[i]
		}
		return x
	end
	
	def line_y(n)
		tmp_y = 0
		0.upto(n) {|i|
			tmp_y += @h[i]
		}
		return y
	end
	
	
	def save(io)
		Marshal.dump(@x_max, io)
		Marshal.dump(@y_max, io)
		Marshal.dump(@w, io)
		Marshal.dump(@h, io)
		Marshal.dump(@sheet_x, io)
		Marshal.dump(@sheet_y, io)
	end
	
	def load(io)
		@x_max = Marshal.load(io)
		@y_max = Marshal.load(io)
		@w = Marshal.load(io)
		@h = Marshal.load(io)
		@sheet_x = Marshal.load(io)
		@sheet_y = Marshal.load(io)
	end
end
